<?xml version="1.0"?>

<!--
   required params:
   id = the project id
-->

<niku:template xmlns:niku="http://www.niku.com/xql">
   <niku:custom name="teamList" class="com.niku.projmgr.xql.handlers.TeamListHandler"/>
   <niku:custom name="LockHandler" class="com.niku.projmgr.xql.handlers.ProjectLockHandler"/>
   <niku:custom name="dateConvertHandler" class="com.niku.projmgr.xql.handlers.DateConvertHandler"/>
   <niku:function name="hasRecords" class="com.niku.projmgr.xql.functions.HasRecords"/>
   <niku:function name="getSortField" class="com.niku.xmlserver.xql.functions.GetSortField"/>
   <niku:function name="getRecordCount" class="com.niku.xmlserver.xql.functions.RecordCount"/>
   <niku:function name="formatIDs" class="com.niku.projmgr.xql.functions.FormatIDs"/>
   
   <TEAM_DATA>

      <!-- The following query for collaboration is taken directly from the modulemanagment.xql
           It's here to be able to do the rights check to show the document tab
           Bug Fix # 50671
      -->
      <niku:sql prepare="true" name="enableCollaboration">
         SELECT CATEGORY_ID as ID
         FROM   NTD_CATEGORIES
         WHERE  OBJECT_ID=?
				<niku:parameter position="1" value="{$id}" type="int"/>
      </niku:sql>

      <niku:if test="{not hasRecords('enableCollaboration')}">
         <COLLABORATION_MODULE value="notEnabled" folderId="0"/>
         <niku:else>
            <niku:sql prepare="true" name="clbFolderId">
                  SELECT ID
                  FROM   CLB_DMS_FOLDERS
                  WHERE  ASSOC_OBJ_ID=?
                  AND    ASSOC_OBJ_TYPE='Projects'
							<niku:parameter position="1" value="{$id}" type="int"/>
            </niku:sql>
            <niku:variable name="clbFolderId" value="0"/>
            <niku:for-each select="clbFolderId">
               <niku:variable name="clbFolderId" value="{@ID}"/>
            </niku:for-each>
            <COLLABORATION_MODULE value="enabled" folderId="{$clbFolderId}"/>
         </niku:else>
      </niku:if>


      <niku:if test="{$reload is null or $reload = ''}">
         <niku:variable name="reload" value="true"/>
      </niku:if>
      
      <!-- the following check stops a timed out session from causing a failure if the page as been paginated -->      
      <niku:if test="{$reload = 'false'}">
         <niku:if test="{isCacheExpired('projectTeamList')}">
            <niku:variable name="reload" value="true"/>
         </niku:if>
      </niku:if>
   
	   <!-- add XML to determine 'enable' or 'remove' of different modules -->
	   <niku:sql name="enableManagement">
         SELECT	prID, prClosedTime
         FROM	   PRJ_PROJECTS
         WHERE	   PRJ_PROJECTS.prID={$id}
      </niku:sql>
   	
      <niku:if test="{not hasRecords('enableManagement')}">
         <MANAGEMENT_MODULE value="notEnabled"/>
         <niku:else>
            
            <niku:variable name="managementActive" value="true"/>
            
            <niku:for-each select="enableManagement">
               <niku:if test="{@prClosedTime != null and @prClosedTime != ''}">
                  <niku:variable name="managementActive" value="false"/>
               </niku:if>
            </niku:for-each>
            <MANAGEMENT_MODULE value="enabled" active="{$managementActive}"/>
         </niku:else>
      </niku:if>
      
      <niku:include href="enableAdvResReqs.xql"/>
     
      <RESOURCE_TYPE_LIST_DATA restype="{$restype}">
         <niku:sql source="jdbc" name="qryResourceType">
            SELECT   ID, NAME, LOOKUP_ENUM
            FROM     CMN_LOOKUPS_V
            WHERE    LOOKUP_TYPE='RESOURCE_TYPE' AND LANGUAGE_CODE='{$userLanguage}'
            ORDER BY NAME
         </niku:sql>
         <!-- note: Labor (=0) is the default -->
         <niku:for-each select="qryResourceType">
            <VALUE name="{@NAME}" value="{@LOOKUP_ENUM}" default="{boolean(@LOOKUP_ENUM = $restype)}"/>
         </niku:for-each>
      </RESOURCE_TYPE_LIST_DATA>

     <niku:view name="TeamList" userid="{$userID}"/>

      <niku:if test="{$enableAdvResReqs}">
         <niku:removeFromView key="prStatus" tag="FIELD" attribute="name"/>
      </niku:if>
            
      <niku:if test="{$enableAdvResReqs}">
         
      <niku:variable name="internalUser" value="true"/>
      <niku:if test="{$userType = 'EXTERNAL'}">
            <niku:variable name="internalUser" value="false"/>
      </niku:if>
         
         <niku:sql name="reqForProject">
            SELECT   ID 
            FROM     RSM_REQ_REQUISITIONLIST_V
            WHERE    PROJECT_ID={$id}
         </niku:sql>
         
         <niku:variable name="requisitionForProject" value="false"/>
         
         <niku:for-each select="reqForProject">
            <niku:variable name="requisitionForProject" value="true"/>
         </niku:for-each>
         
         <niku:if test="{not $internalUser}">
            <niku:if test="{not $requisitionForProject}">
               <niku:variable name="enableAdvResReqs" value="false"/>
            </niku:if>
         </niku:if>
      </niku:if>

      <niku:sql name="project">
         SELECT  prID, prUserName, prName, prStart, prFinish, prTrackMode, prIsOpen, prExternalID, prPriority
         FROM    PRProject
         WHERE   prID={$id}
      </niku:sql>

      <!-- Set restype, if defined -->
      <niku:variable name="teamFormSQL" value=""/>
      <niku:variable name="prresFormSQL" value=""/>
      <niku:if test="{$restype != null and $restype != ''}">
         <niku:variable name="teamFormSQL" value="{$teamFormSQL} AND SRM_RESOURCES.RESOURCE_TYPE = {$restype}"/>
         <niku:variable name="prresFormSQL" value="{$prresFormSQL} AND PRResource.RESOURCE_TYPE = {$restype}"/>
      </niku:if>
      
      <niku:for-each select="project">

         <niku:LockHandler project="project"/>

         <niku:if test="{!project.ProjectViewManagement}">

            <niku:if test="{@prTrackMode = 0}"> <!-- change the allocation caption based on project type -->
               <niku:changeCaption newCaption="allocation" tag="FIELD" attribute="caption" key="remainingAlloc"/>
            </niku:if>
            
            <!-- All records for the team associated with the project -->
            <!-- only obtain the main fields for this query and get the curves and such later on by the handler -->

            <niku:sql name="projectTeamList" cache="true" reload="{$reload}">
               SELECT PRTeam.prID, PRTeam.prResourceID, PRTeam.prAvailStart, PRTeam.prAvailFinish, PRTeam.prRoleID, PRTeam.prProjectID,
                      SRM_RESOURCES.RESOURCE_TYPE, SRM_RESOURCES.FIRST_NAME, SRM_RESOURCES.LAST_NAME, {viewSelect('TeamList')}
               FROM   PRTeam, SRM_RESOURCES
               WHERE  PRTeam.prProjectID={$id}
               AND    PRTeam.prResourceID=SRM_RESOURCES.ID
                  {$teamFormSQL}               
            </niku:sql>
     
            <!-- When clicking on a column header to resort the list the resort parameter will be passed with the
                 name of the field to sort on as its value -->
                 
            <!-- sortField and sortOrder are overrides during a column sort request. If they aren't passed
                  then the getSortField function will set them, otherwise it just modifies the VIEW document 
                  to set the appropriate FIELD element. -->

            <niku:variable name="sortField" value="{getSortField('TeamList',$sortField, $sortOrder)}"/>
            <niku:if test="{$reload}">
               <niku:filter select="projectTeamList" filter="{viewFilter('TeamList',$userID)}"/>            
               <niku:sort select="projectTeamList" field="{$sortField}" ascending="{$sortOrder}"/>
               <niku:else>
                  <niku:if test="{$resort}">
                     <niku:sort select="projectTeamList" field="{$sortField}" ascending="{$sortOrder}"/>
                  </niku:if>
               </niku:else>
               
            </niku:if>
            
            <!-- All resources associated with the team without the avail curve  or the calendar id-->
            <niku:sql name="resources">
               SELECT   PRResource.prID, PRResource.prIsRole, PRResource.RESOURCE_TYPE,
                        PRResource.prID AS resID, PRResource.prParentID, PRResource.prDOH, PRResource.prDOT,
                        SRM_RESOURCES.FULL_NAME
               FROM     PRResource, PRTeam, SRM_RESOURCES
               WHERE    PRTeam.prResourceID=PRResource.prID
               AND      PRTeam.prResourceID=SRM_RESOURCES.ID
               AND      PRTeam.prProjectID={$id}
                     {$prresFormSQL}               
               ORDER BY    PRResource.prID
            </niku:sql>

            <!-- All resources associated with the team that have a role id-->
            <niku:sql name="teamRoles">
               SELECT      ID, LAST_NAME
               FROM        SRM_RESOURCES, PRTeam
               WHERE       SRM_RESOURCES.ID = PRTeam.prRoleID
               AND         PRTeam.prProjectID={$id}
               ORDER BY    SRM_RESOURCES.ID
            </niku:sql>

            <niku:sql name="assignments">
               SELECT      0 as ID, PRAssignment.prResourceID,
                           SUM(PRAssignment.prActSum) AS prActSum,
                           SUM(PRAssignment.prEstSum) AS prEstSum,
                           MAX(PRAssignment.prActThru) AS prActThru
               FROM        PRAssignment, PRTask
               WHERE       PRAssignment.prTaskID=PRTask.prID
               AND         PRTask.prProjectID={$id}
               GROUP BY    PRAssignment.prResourceID
               ORDER BY    PRAssignment.prResourceID
            </niku:sql>
            <niku:variable name="projManager" value="{!project.ProjectEditManagement}"/>
   
            <!-- aggregation variables -->
            <niku:variable name="actSum" value="{0.0}"/>
            <niku:variable name="estSum" value="{0.0}"/>
            <niku:variable name="allocSum" value="{0.0}"/>
            <niku:variable name="remAllocSum" value="{0.0}"/>
            
            <niku:variable name="bookingRight" value="false"/>
            
            <niku:if test="{checkRight('-1', 'PRJ_RESOURCE', 'RECORD', 'ResourceSoftBook', 'PRJ', 'base')}">
               <niku:variable name="bookingRight" value="true"/>
            </niku:if>

         <niku:variable name="idstr" value="{formatIDs('projectTeamList','prID',$max_list_size,$from)}"/>
         <niku:if test="{$idstr != ''}">
            <niku:sql name="curves">
               SELECT   PRTeam.prID AS prID, PRTeam.prAllocCurve, PRTeam.prResourceID AS prResourceID,
                        PRResource.prAvailCurve, PRCalendar.prValue
               FROM     PRTeam, PRResource, PRCalendar
               WHERE    PRTeam.prResourceID = PRResource.prID
               AND      PRResource.prCalendarID = PRCalendar.prID
               AND      PRTeam.prID IN ({$idstr})
               ORDER BY PRTeam.prID
            </niku:sql>
         </niku:if>

            <niku:variable name="record_count" value="{getRecordCount('projectTeamList')}"/>

            <DATA object="TeamList" reqsEnabled="{$enableAdvResReqs}" record_count="{$record_count}">

               <niku:for-each select="projectTeamList" from="{$from}" count="{$max_list_size}">
                   
                   <niku:for-each select="resources[prID=@projectTeamList.prResourceID]">
                    
                    <niku:variable name="actuals" value="{0.0}"/>
                    <niku:variable name="estimates" value="{0.0}"/>
                    
                     <niku:if test="{@resources.RESOURCE_TYPE = '0' or @resources.RESOURCE_TYPE = '1'}">
                        <niku:variable name="cvtval" value="3600"/>
                     <niku:else>
                        <niku:variable name="cvtval" value="1"/>
                     </niku:else>
                     </niku:if>
                    
                    <niku:for-each select="assignments[prResourceID=@resources.prID]">
                       <niku:variable name="actuals" value="{double(@assignments.prActSum) / double($cvtval)}"/>
                       <niku:variable name="estimates" value="{double(@assignments.prEstSum) / double($cvtval)}"/>
                       <niku:variable name="ActThrough" value="{@assignments.prActThru}"/>
                    </niku:for-each>

                     <niku:if test="{$ActThrough != null}">
                        <niku:dateConvertHandler dateValue="{$ActThrough}"/>                       
                        <niku:else>
                           <niku:if test="{@projectTeamList.prAvailStart = null}">
                              <niku:if test="{@project.prStart &lt; $now}">
                                 <niku:dateConvertHandler dateValue="{$now}"/>
                                 <niku:else>
                                    <niku:dateConvertHandler dateValue="{@project.prStart}"/>
                                 </niku:else>
                              </niku:if>
                              <niku:else>
                                 <niku:if test="{@projectTeamList.prAvailStart &lt; $now}">
                                    <niku:dateConvertHandler dateValue="{$now}"/>
                                    <niku:else>
                                       <niku:dateConvertHandler dateValue="{@projectTeamList.prAvailStart}"/>
                                    </niku:else>
                                 </niku:if>
                              </niku:else>
                           </niku:if>
                        </niku:else>
                     </niku:if>

                     <niku:variable name="startDateMilli" value="{$convertedDate}"/>
                     
                     <niku:if test="{@projectTeamList.prAvailFinish = null}">
                        <niku:if test="{@project.prFinish &lt; $now}">
                           <niku:dateConvertHandler dateValue="{$now}"/>
                           <niku:else>
                              <niku:dateConvertHandler dateValue="{@project.prFinish}" pm="true"/>
                           </niku:else>
                        </niku:if>
                        <niku:else>
                           <niku:if test="{@projectTeamList.prAvailFinish &lt; $now}">
                              <niku:dateConvertHandler dateValue="{$now}"/>
                              <niku:else>
                                 <niku:dateConvertHandler dateValue="{@projectTeamList.prAvailFinish}" pm="true"/>
                              </niku:else>
                           </niku:if>
                        </niku:else>
                     </niku:if>
                     
                     <niku:variable name="finishDateMilli" value="{$convertedDate}"/>
                     
                     <niku:variable name="roleID" value=""/>
                     <niku:variable name="resourceID" value=""/>
                     
                     <!-- only set one value because the resfinder stuff only wants one or the other -->
                     <niku:if test="{@resources.prIsRole}">
                        <niku:variable name="roleID" value="{@resources.resID}"/>
                        <niku:variable name="editRight" value="{$projManager}"/>
                        <niku:else>
                           <niku:variable name="resourceID" value="{@resources.resID}"/>
                           <niku:variable name="roleID" value="{@projectTeamList.prRoleID}"/>  <!-- use the team role id if the resource has one -->
                           <niku:variable name="editRight" value="{!resources.ResourceSoftBook}"/>
                        </niku:else>
                     </niku:if>
                     <!-- end variables for the viewFields handler -->
   
                     <niku:variable name="parentRoleId" value="{@resources.prParentID}"/>
                     <niku:variable name="replaceString" value="{@prName}"/>
                                                             
                    <niku:variable name="roleName" value=""/>
                    <niku:if test="{bsearch('teamRoles','ID', @projectTeamList.prRoleID )}">
                       <niku:variable name="roleName" value="{@teamRoles.LAST_NAME}"/>
                    </niku:if>
                    
                     <niku:variable name="doresfind" value="{boolean((@resources.RESOURCE_TYPE = '0') and ((@prIsRole and $bookingRight) or ((not @prIsRole) and $editRight)))}"/>
                     <niku:if test="{$doresfind}">
                     <niku:else>
                        <niku:variable name="callreq" value="teamList.id={@projectTeamList.prID}"/>
                        <niku:variable name="listreq" value="selectResourcesAddStaff.typematch={@resources.RESOURCE_TYPE}"/>
                     </niku:else>
                     </niku:if>
                     
                    <VALUE
                       prID      = "{@projectTeamList.prID}"
                       editRight = "{$editRight}"
                       resID		= "{@resources.resID}"
                       teamID		= "{@projectTeamList.prID}"
                       select    = "item.{@projectTeamList.prID}"
                       edit      = "Edit"
                       selectValue="{@resources.FULL_NAME}"
                       >

                       <niku:attribute name="search" value="ResourceFinder"/>
                       
                       <niku:attribute name="actuals" value="{$actuals}"/>
                       <niku:attribute name="estimates" value="{$estimates}"/>

                       <niku:attribute name="roleName" value="{$roleName}"/>

                       <niku:variable name="allocation" value=""/>
                       <niku:variable name="remAllocation" value=""/>
                       <niku:variable name="pctAllocation" value=""/>
                       
                       <!-- <niku:teamList project="project" team="projectTeamList" resources="resources" calendars="calendars" assignments="assignments"/> -->
                       <niku:if test="{bsearch('curves','prID',@projectTeamList.prID)}">
                          <niku:teamList project="project" team="projectTeamList" resources="resources" curves="curves" assignments="assignments"/>
                       </niku:if>
                     
                       <niku:attribute name="allocation" value="{$allocation}"/>
                       <niku:attribute name="remAllocation" value="{$remAllocation}"/>
                       <niku:attribute name="pctAllocation" value="{$pctAllocation}"/>
                       
                       <!-- another variable for the resfinder request. -->
                       <niku:if test="{$pctAllocation = null or $pctAllocation = ''}">
                          <niku:variable name="pctAlloc" value="100"/>
                       <niku:else>
                          <niku:variable name="pctAlloc" value="{$pctAllocation}"/>
                       </niku:else>
                       </niku:if>

                       <niku:viewFields name="TeamList"/>

                       <niku:if test="{@projectTeamList.prAvailStart = null}">
                          <niku:attribute name="prAvailStart" value="{@project.prStart}"/>
                       </niku:if>
                       <niku:if test="{@projectTeamList.prAvailFinish = null}">
                          <niku:attribute name="prAvailFinish" value="{@project.prFinish}"/>
                       </niku:if>
                       
                       <niku:variable name="actSum" value="{double($actSum) + double($actuals)}"/>
                       <niku:variable name="estSum" value="{double($estSum) + double($estimates)}"/>
                       <niku:variable name="allocSum" value="{double($allocSum) + double($allocation)}"/>
                       <niku:variable name="remAllocSum" value="{double($remAllocSum) + double($remAllocation)}"/>

                    </VALUE>
                 </niku:for-each>
              </niku:for-each>                  
              
              <niku:attribute name="buttonRight" value="{$projManager or $bookingRight}"/>
              <niku:attribute name="bookingRight" value="{$bookingRight}"/>
              <niku:attribute name="managementRight" value="{$projManager}"/>
  
            </DATA>
            
            <niku:viewIndex select="projectTeamList" from="{$from}" count="{$max_list_size}" size="{$max_list_size}" field="{$sortField}"/>
            
            <niku:else>
               <EXCEPTION error="1007_PROJECT_VIEWER" type="RightsException" />
            </niku:else>
         </niku:if>

         <!-- Project summary -->
         <PROJECT id="{@project.prID}" name="{@project.prName}" externalId="{@project.prExternalID}" startDate="{@project.prStart}" finishDate="{@project.prFinish}" trackMode="{@project.prTrackMode}" isOpen="{@project.prIsOpen}" prProjectManager="{!prProjectManager}">
            <niku:sql name="maxActThrough">
               SELECT      0 as ID, MAX(PRAssignment.prActThru) AS maxActThrough
               FROM        PRTask,   PRAssignment
               WHERE       PRTask.prProjectID={@project.prID}
               AND         PRAssignment.prTaskID=PRTask.prID
            </niku:sql>
            <niku:for-each select="maxActThrough">
               <niku:attribute name="ProgressThrough" value="{@maxActThrough.maxActThrough}"/>
            </niku:for-each>

           <niku:sql name="td_test">
               SELECT   prID, prExternalID
               FROM     PRTask
               WHERE    prProjectID = {$id}
               AND      prExternalID = '~rmw'
           </niku:sql>
           <niku:for-each select="td_test">
              <niku:attribute name="topDown" value="{@prExternalID}"/>
           </niku:for-each>

            <niku:attribute name="locked" value="{$locked}"/>
            <niku:attribute name="estimate" value="{$estSum}"/>
            <niku:attribute name="allocation" value="{$allocSum}"/>
            <niku:attribute name="remainingAllocation" value="{$remAllocSum}"/>
            <niku:attribute name="variance" value="{double($remAllocSum) - double($estSum)}"/>
            <niku:attribute name="actuals" value="{integer($actSum)}"/>
    		   <niku:attribute name="prID" value="{$id}"/>

            <niku:variable name="totalEffort" value="{double($actSum) + double($estSum)}"/>
            <niku:attribute name="totalEffort" value="{$totalEffort}"/>
            <niku:if test="{double($totalEffort) > 0.0}">
              <niku:attribute name="percentComplete" value="{double($actSum) / double($totalEffort)}"/>
              <niku:else>
                <niku:attribute name="percentComplete" value="0.0"/>
              </niku:else>
            </niku:if>
         </PROJECT>

      </niku:for-each>
      
   </TEAM_DATA>
   
</niku:template>